#include "xmms2_plugin.h"


int
mod_controller_playlist_new(void *data, Emusic_Controller *controller, char *playlist_name)
{
  if ( ! data || !controller )
    return 0;

  /**
   * TODO
   * Using medialib add create a new playlist.
   */

  Emusic_Xmms2_Private *priv;
  Emusic_Playlist* playlist;

  priv = (Emusic_Xmms2_Private *)data;

  playlist = (Emusic_Playlist*)calloc(1, sizeof(Emusic_Playlist));
  playlist->name = strdup(playlist_name);
  playlist->files = _xmms_playlist_populate(priv);
  playlist->index = ecore_list_nodes(playlist->files);

  ecore_list_append(controller->playlists, playlist);

  printf("ecore_list_goto\n");
  ecore_list_goto(controller->playlists, playlist);


  return 1;
}


int
mod_controller_playlist_add(void *data, Emusic_Controller *controller, char* filename)
{
  if ( ! data || !controller || !filename )
    return 0;

  Emusic_Xmms2_Private *priv;
  Emusic_Playlist *playlist = NULL;
  char *url = NULL;

  priv = (Emusic_Xmms2_Private *)data;

  if (! ( playlist = ecore_list_current(controller->playlists) ) )
    {
      printf("playlist doesn't exists !");
      return 0;
    }

  url = _xmms_format_url(filename);
  if (!url)
    {
      printf("Invalid url.\n");
      return 0;
    }

  priv->res = xmmsc_playlist_add(priv->con, url);
  xmmsc_result_wait(priv->res);

  if (xmmsc_result_iserror(priv->res))
    {
      _xmms_print_iserror(priv->res, __func__, __LINE__);
      return 0;
    }
  xmmsc_result_unref(priv->res);
  ecore_list_append(playlist->files, strdup(filename));
  //printf("bointe here ? :)\n");
  playlist->index++;

  return 1;
}

int
mod_controller_playlist_remove(void *data, Emusic_Controller *controller, char* filename)
{
  if ( ! data || !controller )
    return 0;

  Emusic_Xmms2_Private *priv;
  priv = (Emusic_Xmms2_Private *)data;

  return 1;
}

int
mod_controller_playlist_destroy(void *data, Emusic_Controller *controller)
{
  return 1;
}

char*
mod_controller_playlist_save(void *data, Emusic_Controller *controller, char* filename)
{
  if ( ! data || !controller )
    return 0;

  Emusic_Xmms2_Private *priv;
  priv = (Emusic_Xmms2_Private *)data;

  priv->res = xmmsc_medialib_playlist_save_current(priv->con, controller->name);
  xmmsc_result_wait(priv->res);

  if (xmmsc_result_iserror(priv->res))
    {
      _xmms_print_iserror(priv->res, __func__, __LINE__);
      return 0;
    }
  xmmsc_result_unref(priv->res);
  return NULL;
}

Emusic_Playlist *
mod_controller_playlist_get(void *data, Emusic_Controller *controller, char *playlist_name)
{
  if ( ! data || !controller || !playlist_name )
    return NULL;

  Emusic_Playlist *ep = NULL;

  ecore_list_goto_first(controller->playlists);
  while ( ep = ecore_list_next(controller->playlists) )
    {
      if ( ! strcasecmp(ep->name, playlist_name) )
        {
          ecore_list_goto(controller->playlists, ep);
          return ep;
        }
    }
  return NULL;
}



Ecore_List *_xmms_playlist_populate(Emusic_Xmms2_Private *priv)
{
  Ecore_List *pl = NULL;

  pl = ecore_list_new();
  ecore_list_init(pl);

  priv->res = xmmsc_playlist_list(priv->con);
  xmmsc_result_wait(priv->res);

  if (xmmsc_result_iserror(priv->res))
    {
      _xmms_print_iserror(priv->res, __func__, __LINE__);
      return NULL;
    }

  while (xmmsc_result_list_valid(priv->res))
    {
      xmmsc_result_t *info_res;
      char *url;
      unsigned int ui = 0;

      if (!xmmsc_result_get_uint(priv->res, &ui))
        {
          printf("broken resultset\n");
          return NULL;
        }

      info_res = xmmsc_medialib_get_info(priv->con, ui);
      xmmsc_result_wait(info_res);

      if (xmmsc_result_iserror(info_res))
        {
          _xmms_print_iserror(info_res, __func__, __LINE__);
          return NULL;
        }

      if (xmmsc_result_get_dict_entry_str(info_res, "url", &url))
        {
          ecore_list_append(pl, strdup(url));
        }
      xmmsc_result_unref(info_res);
      xmmsc_result_list_next(priv->res);
    }
  xmmsc_result_unref(priv->res);


  return pl;
}
