#ifndef XMMS_PLUGIN_H
#define XMMS_PLUGIN_H

#include "Emusic.h"
#include "emusic_private.h"
#include <xmmsclient/xmmsclient.h>


#define EMUSIC_XMMS2_CLIENT_NAME "emusic"

typedef struct _Emusic_Xmms2_Private Emusic_Xmms2_Private;


struct _Emusic_Xmms2_Playlist_Item_Info
  {

  }
;

struct _Emusic_Xmms2_Private
  {
    xmmsc_connection_t *con;
    xmmsc_result_t     *res;

    char *ipc_path;

    Ecore_List *controllers;
    int         controllers_count;

  };

void                  _xmms_print_iserror(xmmsc_result_t *res, const char *func, signed int line);
void                  _xmms_controller_remove_destroy_cb(void *data);


char                  *_xmms_format_url(char *path);
Ecore_List            *_xmms_playlist_populate(Emusic_Xmms2_Private *priv);
int                    _xmms_get_current_song_id(Emusic_Xmms2_Private *priv);
int                    _xmms_controller_jump_to(Emusic_Xmms2_Private *priv, int pos);



/* module */
int 	               mod_init(void** data);
int 	               mod_shutdown(void *data);
Emusic_Controller*     mod_controller_new(void *data, char* name);
int	               mod_controller_remove(void *data, Emusic_Controller *controller);
char	              *mod_controller_name_get(void *data, Emusic_Controller *controller);
int 	               mod_controller_name_set(void *data, Emusic_Controller *controller, char* name);
Emusic_Controller_Mode mod_controller_mode_get(void *data, Emusic_Controller *controller);
int                    mod_controller_mode_set(void *data, Emusic_Controller *controller, Emusic_Controller_Mode mode);
int                    mod_controller_playlist_new(void *data, Emusic_Controller *controller, char *playlist_name);
int                    mod_controller_playlist_add(void *data, Emusic_Controller *controller, char* filename);
int                    mod_controller_playlist_remove(void *data, Emusic_Controller *controller, char* filename);
int                    mod_controller_playlist_destroy(void *data, Emusic_Controller *controller);
char                  *mod_controller_playlist_save(void *data, Emusic_Controller *controller, char* filename);
Emusic_Playlist       *mod_controller_playlist_get(void *data, Emusic_Controller *controller, char *playlist_name);
int                    mod_controller_play(void *data, Emusic_Controller *controller);
int                    mod_controller_pause(void *data, Emusic_Controller *controller);
int                    mod_controller_stop(void *data, Emusic_Controller *controller);
int                    mod_controller_next(void *data, Emusic_Controller *controller);
int                    mod_controller_prev(void *data, Emusic_Controller *controller);
double                 mod_controller_volume_get(void *data, Emusic_Controller *controller);
int                    mod_controller_volume_set(void *data, Emusic_Controller *controller, double volume);
double                 mod_controller_length_get(void *data, Emusic_Controller *controller);

#endif
