#include "xmms2_plugin.h"

int _xmms_get_current_song_id(Emusic_Xmms2_Private *priv)
{
  int id = 0;

  priv->res = xmmsc_playback_current_id(priv->con);
  xmmsc_result_wait(priv->res);

  if (xmmsc_result_iserror(priv->res))
    {
      _xmms_print_iserror(priv->res, __func__, __LINE__);
      return 0;
    }

  xmmsc_result_get_uint(priv->res, &id);

  xmmsc_result_unref(priv->res);

  return id;
}


char *_xmms_format_url(char *path)
{
  char *url = NULL, rpath[1024], *p;

  url = calloc(1, 512);

  p = strchr(path, ':');
  if (!(p && p[1] == '/' && p[2] == '/'))
    {	 /* wrong url... */

      if (!realpath (path, rpath))
        {
          return NULL;
        }
      sprintf(url, "file://%s", rpath);
    }
  else
    {
      url = path;
    }

  return url;
}


void _xmms_controller_remove_destroy_cb(void *data)
{
  Emusic_Controller *ec = (Emusic_Controller *)data;

  free(ec->name);
  //EMUSIC_FREE(ec->playlist);
  free(ec);
}


void _xmms_print_iserror(xmmsc_result_t *res, const char *func, signed int line)
{
  printf("XMMS2 INTERNAL ERROR :\n"
         "FUNCTION.............: %s:%d :\n"
         "ERROR................: %s\n",
         func, line, xmmsc_result_get_error(res));
}
